CON
        _clkmode = xtal1 + pll16x                                               'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000

        CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
        MS_001   = CLK_FREQ / 1_00

        RX  = 31                                                     ' programming / terminal
        TX  = 30

        strippin = 23                                                     ' LED tx pin
        stripchan = 3
        ledcount = 128           

        dmxpin = 14
        dmxledpin = 0
        DMX_START_byte = 0                                                 ' monitor channels 1 - 6
        defaultdata = 0  

OBJ
  serial  : "my_PBnJ_serial"
  strip : "jm_ws2812"                                           ' WS2812 LED driver
  dmx   : "jm_dmxin"
  ''dmx   : "jm_dmxin-timestamp"

var
  long stack1[16]
      
pub main | j
  serial.Start(RX,TX,115_200)
  strip.start(strippin, ledcount)                                          ' start led driver
  dmx.init(dmxpin, dmxledpin, DMX_START_byte, defaultdata)
  pause(10)

  repeat
''    serial.hex(long[dmx.counter][0],8)
    serial.dec(clk_freq/long[dmx.counter][0])
    serial.tx(13)
    repeat j from 0 to ledcount-1      
      strip.set_rgb(j,dmx.read(j*stripchan+1),dmx.read(j*stripchan+2),dmx.read(j*stripchan+3))

pub pause(ms) | t

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)
    waitcnt(t += MS_001)
        